Attribute VB_Name = "modExcelExport"
' vb@rchiv - Das groe Visual-Basic Archiv
' Tools & Components - Entwicklerkomponenten fr VB-32 Bit
'
' Copyright 2000-2010 Dieter Otter
' Tipp-Autor: Julis Lszl
'
' Der Programmcode darf fr eigene Zwecke verwendet werden.
' Es ist nicht erlaubt Inhalte des Projektes ohne unserer
' Zustimmung zum Download anzubieten.
'
' Die Beispielskripte sind Computerprogramme, die gem
' des 2 Abs. 1 Nr. 69 aff. UrhG den urheberrechtlichen
' Schutz geniessen und drfen nicht fr eigene ausgegeben
' werden.
'
' Dieter Otter
' Software-Entwicklung & Vertrieb
' info@vbarchiv.de
' http://www.vbarchiv.de
' http://www.visualbasic-archiv.de
'
' info@tools4vb.de
' http://www.tools4vb.de
'======================================================

'Die Beispielanwending zeigt, wie man von einer MS-SQL Server Datenbank oder von einer MS-Access Datenbank
'Daten in eine MS-Excel Datei mit einem SQL-Befehl schreibt.
'Das Projekt soll je einen Verweis auf die Microsoft ActiveX Data Objects 2.6 Library (C:\Program Files\Common Files\system\ado\msado26.tlb)
'und auf die Microsoft DAO 3.6 Object Library (C:\Windows\system32\DAO360.dll) enthalten.

Public Declare Function InitCommonControls Lib "comctl32.dll" () As Long

'APIs fr Registry um die ODBC-Datenquellen auszulesen:
Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Const REG_SZ = 1
Const REG_EXPAND_SZ = 2
Const REG_BINARY = 3&
Const REG_DWORD = 4

'APIs zum Ermitteln der vorhandenen OBDC-Datenquellen
Private Declare Function SQLDataSources Lib "ODBC32.DLL" (ByVal _
        henv As Long, _
        ByVal fDirection As Integer, _
        ByVal szDSN As String, _
        ByVal cbDSNMax As Integer, _
        pcbDSN As Integer, _
        ByVal szDescription As String, _
        ByVal cbDescriptionMax As Integer, _
        pcbDescription As Integer) _
        As Integer
        
Private Declare Function SQLAllocEnv Lib "ODBC32.DLL" ( _
        env As Long) _
        As Integer

Const SQL_SUCCESS As Long = 0
Const SQL_FETCH_NEXT As Long = 1

'MS-Access Datenbankpasswort:
Public sPasswort As String

Public Sub Main()

 sPasswort = "StrengsteGeheimsache"
 InitCommonControls
 frmMain.Show 1
 
End Sub

Public Sub SQLServerEinbinden(DBNAME As String, DBCONNECT As String, UID As String, PWD As String)

 'Hier wird ein MS-Access Datenbank erstellt und die orig. SQL Server Datenbank-Tabellen eingebunden.
 'Die eingebundenen Tabellen werden von der Jet-Engine nicht als SQL Server-Tabellen, sondern wie Access-Tabellen gehandhabt,
 'so ist die Mglichkeit vorhanden, von der SQL Server Datenbank Daten in eine Excel-Datei durch einen einzigen SQL-Befehl zu schreiben,
 'da die Jet-Engine die meisten gngigen Datenbank-Formate (MS-Access und MS-Excel auch) kennt.
 'So wird MS-Access als Frontend und der MS SQL-Server als Backend verwandt.
 'Um die SQL Server Tabellen in eine Access Datenbank einzubinden, mu eine ODBC-Datenquelle mit Verweis auf die SQL Server Datenbank vorhanden sein.
 'Die Beispielanwendung funktioniert mit SQL Server Authentifizierung.
 'Die ODBC-Datenquelle mu als System-DSN definiert werden (siehe z.B.: http://www.vbarchiv.net/tipps/details.php?id=1419).

 On Local Error GoTo SQLServerEinbindenFehler

 Screen.MousePointer = 11
 Dim Obj As Object
 Dim DB As DAO.Database
 Dim SQLDB As DAO.Database
 Dim Td As DAO.TableDef
 Dim i As Integer
 
 Dim TDQuery As DAO.QueryDef
 
 'ffnen der SQL Server Datenbank:
 Set SQLDB = OpenDatabase(DBNAME, dbDriverCompleteRequired, True, "ODBC;DATABASE=" + DBCONNECT + ";UID=" + UID + ";pwd=" + PWD + ";DSN=" + DBCONNECT + ";")
 'Erstellen einer MS-Access Datenbank mit Passwort:
 'ACHTUNG! Passwort (sPasswort) immer verwenden, weil die Access Datenbank einen direkten Zugriff auf die eingebundenen SQL Server Tabellen bereitstellt!
 Set DB = CreateDatabase(App.Path + "\SQLConnect.mdb", dbLangGeneral & ";pwd=" & sPasswort, dbEncrypt)
 Set DB = Nothing
 'ffnen der Access Datenbank:
 Set DB = OpenDatabase(App.Path + "\SQLConnect.mdb", False, False, ";pwd=" & sPasswort)

 frmMain.ProgressBar1.Max = SQLDB.TableDefs.Count
 On Local Error Resume Next
 'Ermitteln der SQL Server Tabellen:
 For Each Obj In SQLDB.TableDefs
  i = i + 1
  frmMain.ProgressBar1.Value = i
  'Tabellendefinition in der Access Datenbank:
  If InStr(1, Obj.Name, ".") > 0 Then
   'Wenn die Tabellen-Name in der SQL Server Datenbank z.B. folgende Schema folgt: "dbo.Tabelle"
   Set Td = DB.CreateTableDef(Right(Obj.Name, Len(Obj.Name) - InStr(1, Obj.Name, ".")), dbAttachSavePWD)
  Else
   'Wenn die Tabellen-Name in der SQL Server Datenbank folgende Schema folgt: "Tabelle"
   Set Td = DB.CreateTableDef(Obj.Name, dbAttachSavePWD)
  End If
  'Verknpfung zur aktuellen SQL Server Tabelle:
  Td.Connect = "ODBC;DATABASE=" + DBCONNECT + ";UID=" + UID + ";PWD=" + PWD + ";DSN=" + DBNAME
  Td.SourceTableName = Obj.Name
  'Tabellen-Objekt in der Access Datenbank erstellen:
  DB.TableDefs.Append Td
 Next
 
 frmMain.ProgressBar1.Value = 0

 frmMain.SteuerElemente
 Set SQLDB = Nothing
 Set DB = Nothing
 Set Td = Nothing
 Screen.MousePointer = 0
 
 Exit Sub
 
SQLServerEinbindenFehler:
 MsgBox Err.Description, vbOKOnly + vbInformation, Err
 Screen.MousePointer = 0
 frmMain.ProgressBar1.Value = 0

End Sub

Sub GetDSNsAndDrivers()
    
 'Ermitteln der vorhandenen OBDC-Datenquellen:
     
 Dim i As Integer
 Dim sDSNItem As String * 1024
 Dim sDRVItem As String * 1024
 Dim sDSN As String
 Dim sDRV As String
 Dim iDSNLen As Integer
 Dim iDRVLen As Integer
 Dim lHenv As Long

 On Local Error Resume Next
    
 If SQLAllocEnv(lHenv) <> -1 Then
  Do Until i <> SQL_SUCCESS
   sDSNItem = Space(1024)
   sDRVItem = Space(1024)
   i = SQLDataSources(lHenv, SQL_FETCH_NEXT, sDSNItem, 1024, iDSNLen, sDRVItem, 1024, iDRVLen)
   sDSN = Left(sDSNItem, iDSNLen)
   sDRV = Left(sDRVItem, iDRVLen)
   If sDSN <> Space(iDSNLen) Then
    frmMain.cmbODBC.AddItem sDSN
   End If
  Loop
 End If
  
End Sub

Public Sub Excel_Export(Connstring As String, SQLBefehl As String)
 
 On Local Error GoTo ExcelExportFehler

 frmMain.CommonDialog1.CancelError = True
 'frmMain.CommonDialog1.DialogTitle = "Irgendwas"
 frmMain.CommonDialog1.Filter = "MS-Excel Dateien (*.xls)|*.xls"
 frmMain.CommonDialog1.FilterIndex = 1
 frmMain.CommonDialog1.Flags = cdlOFNCreatePrompt And cdlOFNPathMustExist And cdlOFNOverwritePrompt And cdlOFNExplorer
 frmMain.CommonDialog1.FileName = App.Path + "\Excel Datei.xls"
 frmMain.CommonDialog1.ShowOpen
 If frmMain.CommonDialog1.FileName = "" Then
  Exit Sub
 End If
 
 Dim ExcelObjekt As Object
 Dim ArbeitsBlatt As String
 Dim DB As DAO.Database
 Dim Con As ADODB.Connection
 Dim Rec As ADODB.Recordset
 
 Set Con = New ADODB.Connection
 Con.Open Connstring
 Set Rec = New ADODB.Recordset
 Rec.CursorType = adOpenKeyset
 Rec.LockType = adLockOptimistic
 
 If Dir(frmMain.CommonDialog1.FileName) <> "" Then
  Set DB = OpenDatabase(frmMain.CommonDialog1.FileName, 0, False, "Excel 8.0")
  ArbeitsBlatt = "ArbeitsBlatt" + Trim(Str(Round(DB.TableDefs.Count / 2)))
  DB.Close
  Set DB = Nothing
 Else
  ArbeitsBlatt = "ArbeitsBlatt"
 End If
 
 'Frhere Excel Datenbank Version: 'Excel 5.0;'
 SQLBefehl = Left(SQLBefehl, InStr(1, LCase(SQLBefehl), " from ")) + " Into [" + ArbeitsBlatt + "] In '" + frmMain.CommonDialog1.FileName + "' 'Excel 8.0;' From " + Right(SQLBefehl, Len(SQLBefehl) - (InStr(1, LCase(SQLBefehl), " from ") + 5))
 TT = Timer
 'Wenn die Excel-Datei noch nicht existiert, wird sie durch Jet-Engine automatisch erstellt:
 Rec.Open SQLBefehl, Con, , , adCmdText
 If InStr(1, Connstring, "SQLConnect.mdb") > 0 Then
  frmMain.lblMeldung1 = "SQL-Befehl in " + Trim(Str(Timer - TT)) + " s ausgefhrt."
 Else
  frmMain.lblMeldung2 = "SQL-Befehl in " + Trim(Str(Timer - TT)) + " s ausgefhrt (19670 Datenstze)."
 End If
 
 'Excel ffnen als ActiveX-Objekt:
 Set ExcelObjekt = CreateObject("Excel.Application")
 'Ab jetzt VBA:
 'Datei ffnen:
 ExcelObjekt.Workbooks.Open FileName:=frmMain.CommonDialog1.FileName
 'Arbeitsblatt whlen:
 ExcelObjekt.Sheets(ArbeitsBlatt).Select
 'Formatierungen:
 ExcelObjekt.Rows("1:1").Select
 With ExcelObjekt.selection.Interior
  .ColorIndex = 15
  .Pattern = 0
 End With
 With ExcelObjekt.selection
  .VerticalAlignment = -4107
  .WrapText = False
  .Orientation = 0
  .ShrinkToFit = False
  .MergeCells = False
 End With
 ExcelObjekt.selection.Font.Bold = True
 ExcelObjekt.Range("A2").Select
 ExcelObjekt.ActiveWindow.FreezePanes = True
 ExcelObjekt.Cells.Select
 ExcelObjekt.Cells.EntireColumn.AutoFit
 ExcelObjekt.Range("A1").Select
 'Weitere Formatierungen, wenn notwendig:
 '...
 '...
 'Datei mit der Formatierung speichern:
 'ACHTUNG! Wenn Excel 2007 vorhanden und Office-SP2 nicht installiert, kann "ActiveWorkbook.Save" problematisch sein!
 ExcelObjekt.ActiveWorkbook.Save
 ExcelObjekt.Visible = True
 Set ExcelObjekt = Nothing
 
 Exit Sub

ExcelExportFehler:
 Select Case Err
  Case 32755: Exit Sub
  Case Else
   MsgBox Err.Description, vbOKOnly + vbInformation, Err
   Screen.MousePointer = 0
 End Select

End Sub
Public Function GetString(hKey As Long, strPath As String, strValue As String)

 Dim ret
 RegOpenKey hKey, strPath, ret
 GetString = RegQueryStringValue(ret, strValue)
 RegCloseKey ret
    
End Function
Function RegQueryStringValue(ByVal hKey As Long, ByVal strValueName As String) As String

 Dim lResult As Long, lValueType As Long, strBuf As String, lDataBufSize As Long
   
 lResult = RegQueryValueEx(hKey, strValueName, 0, lValueType, ByVal 0, lDataBufSize)
 If lResult = 0 Then
  If lValueType = REG_SZ Then
   strBuf = String(lDataBufSize, Chr$(0))
   lResult = RegQueryValueEx(hKey, strValueName, 0, 0, ByVal strBuf, lDataBufSize)
   If lResult = 0 Then
    RegQueryStringValue = Left$(strBuf, InStr(1, strBuf, Chr$(0)) - 1)
   End If
  ElseIf lValueType = REG_BINARY Then
   Dim strData As Integer
   lResult = RegQueryValueEx(hKey, strValueName, 0, 0, strData, lDataBufSize)
   If lResult = 0 Then
    RegQueryStringValue = strData
   End If
  ElseIf lValueType = REG_DWORD Then
   lResult = RegQueryValueEx(hKey, strValueName, 0, 0, strData, lDataBufSize)
   If lResult = 0 Then
    RegQueryStringValue = strData
   End If
  End If
 End If
    
End Function
